SystemOrganization addCategory: #'GRID-Core'!

!String methodsFor: '*grid-core' stamp: 'carlaGriggio 2/9/2012 17:23'!
asCurrencyString
	^self conSeparadorDeMiles! !

!Number methodsFor: '*grid-core' stamp: 'carlaGriggio 2/9/2012 17:23'!
asCurrencyString
	^(self asFloat printShowingDecimalPlaces: 2) conSeparadorDeMiles ! !

Object subclass: #GRIDCellResult
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Core'!

GRIDCellResult class
	instanceVariableNames: 'Instancia'!

GRIDCellResult class
	instanceVariableNames: 'Instancia'!

!GRIDCellResult class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 16:37'!
description
	self subclassResponsibility ! !

!GRIDCellResult class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 10:31'!
uniqueInstance
	Instancia ifNil:[Instancia := self basicNew].
	^Instancia ! !

!GRIDCellResult methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/11/2012 11:24'!
asString
	^self label ! !

!GRIDCellResult methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 16:37'!
description 
	^self class description ! !

!GRIDCellResult methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/7/2011 21:01'!
groupOfReportSubjects 
	^self session informeEnEvaluacion groupOfReportSubjects ! !

!GRIDCellResult methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/7/2011 15:22'!
hasNumericCurrencyResult
	^true! !

!GRIDCellResult methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/17/2012 19:19'!
isAggregable
	^true! !

Object subclass: #GRIDFactory
	instanceVariableNames: 'reportEvaluationScheduler reportRepository reportClass reportBuilderClass reportResultClass reportColumnClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Core'!

GRIDFactory class
	instanceVariableNames: 'factories'!

GRIDFactory class
	instanceVariableNames: 'factories'!

!GRIDFactory classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/27/2012 15:58'!
currentFactory
	^ WACurrentRequestContext value session gridFactory! !

!GRIDFactory classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/27/2012 15:58'!
currentFactory: aFactory
	^ WACurrentRequestContext value session gridFactory: aFactory ! !

!GRIDFactory classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2012 15:29'!
defaultFactory
"It doesn't have to be singleton, because it may be required to have different instances of the same kind of factory, but then there would have to be different accessors for different well known instances of that factory"
	^ factories at: #default ifAbsentPut:[ self new reportRepository: GRIDReportRepository new; reportEvaluationScheduler: GRIDReportEvaluationScheduler new  ]! !

!GRIDFactory classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2012 15:28'!
initialize 
	super initialize.
	factories := Dictionary new.! !

!GRIDFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2012 15:25'!
newBuilder
	^self reportBuilderClass new! !

!GRIDFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/27/2012 16:36'!
newReportResult
	^self reportResultClass new! !

!GRIDFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2012 15:24'!
reportBuilderClass
	^ reportBuilderClass ifNil:[GRIDReportBuilder ]! !

!GRIDFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2012 15:25'!
reportBuilderClass: anObject
	reportBuilderClass := anObject! !

!GRIDFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2012 15:24'!
reportClass
	^ reportClass ifNil:[GRIDReport ]! !

!GRIDFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2012 15:26'!
reportClass: anObject
	reportClass := anObject! !

!GRIDFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2012 15:27'!
reportColumnClass 
	^ reportColumnClass ifNil:[GRIDReportColumn  ]! !

!GRIDFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2012 15:26'!
reportColumnClass: anObject
	reportColumnClass := anObject! !

!GRIDFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/17/2012 18:33'!
reportEvaluationScheduler
	^reportEvaluationScheduler! !

!GRIDFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/17/2012 18:33'!
reportEvaluationScheduler: aReportEvaluationScheduler
	reportEvaluationScheduler := aReportEvaluationScheduler ! !

!GRIDFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/17/2012 18:33'!
reportRepository
	^reportRepository! !

!GRIDFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/17/2012 18:33'!
reportRepository: aReportRepository
	reportRepository := aReportRepository ! !

!GRIDFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2012 15:24'!
reportResultClass
	^ reportResultClass  ifNil:[GRIDReportResult ]! !

!GRIDFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2012 15:27'!
reportResultClass: anObject
	reportResultClass := anObject! !

Object subclass: #GRIDGroupOfReportSubjects
	instanceVariableNames: 'reportEvaluationContext maximumSizeOfReportSubjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Core'!

!GRIDGroupOfReportSubjects methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 07/31/2012 16:27'!
calculateReportValuesOf: aReport
	self resetReportEvaluationContext.
	self reportEvaluationContext report: aReport.
	aReport configureReportEvaluation: self reportEvaluationContext.
	aReport reportResult reportSubjects: self reportSubjects.
	aReport reportResult reportColumns: aReport reportColumns copy.
	self resolveColumnTitlesOf: aReport.
	self resolveColumnValues: aReport.
	aReport cleanAfterReportEvaluation.! !

!GRIDGroupOfReportSubjects methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 12:40'!
configureContextForSubject: anEvaluationSubject 
	self reportEvaluationContext valueForConcern: self configurationAspect is: anEvaluationSubject ! !

!GRIDGroupOfReportSubjects methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/21/2011 13:15'!
maximumSizeOfReportSubjects: aNumber
	maximumSizeOfReportSubjects := aNumber ! !

!GRIDGroupOfReportSubjects methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/21/2011 11:30'!
reportEvaluationContext 
	^reportEvaluationContext! !

!GRIDGroupOfReportSubjects methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 2/9/2012 17:05'!
reportEvaluationContextClass
	^GRIDReportEvaluationContext! !

!GRIDGroupOfReportSubjects methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/21/2011 15:35'!
reportSubjects
	^ maximumSizeOfReportSubjects
		ifNil: [ self allReportSubjects ]
		ifNotNil: [ self allReportSubjects first: (self allReportSubjects size min: maximumSizeOfReportSubjects) ]! !

!GRIDGroupOfReportSubjects methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 2/9/2012 17:05'!
resetReportEvaluationContext 
	reportEvaluationContext:= self reportEvaluationContextClass new.! !

!GRIDGroupOfReportSubjects methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/16/2012 17:20'!
resolveColumnTitlesOf: aReport
	aReport reportColumns do:[:aReportColumn |
		[aReportColumn configureReportEvaluation:  self reportEvaluationContext] on: Error do:[:error |
		 "maybe it wasn't possible to configure the column without a subject and it's not necessary for it's title"].
		aReport reportResult saveColumnTitle: aReportColumn  columnTitle forColumn: aReportColumn.  ]! !

!GRIDGroupOfReportSubjects methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 08/06/2012 15:10'!
resolveColumnValues: aReport
	 aReport reportColumns
		do: [ :aColumn | 
			self willProcessNextColumn.
			self resetReportEvaluationContext.
			self reportEvaluationContext report: aReport.
			aReport configureReportEvaluation: self reportEvaluationContext.
			
			aColumn informe: aReport.
			self reportSubjects 
				do: [ :reportSubject | 
					self configureContextForSubject: reportSubject.
					aColumn report configureReportEvaluation: self reportEvaluationContext.
					aReport
						saveCellResult: (aColumn cellValueForReportData: self reportEvaluationContext)
						forColumn: aColumn
						andReportSubject: reportSubject. ].
		aColumn cleanAfterReportEvaluation ].
	self resolveReportTotals: aReport! !

!GRIDGroupOfReportSubjects methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 07/31/2012 11:05'!
resolveReportTotals: aReport
	aReport reportColumns
		do: [ :aColumn | 
			aReport cleanAfterReportEvaluation.
			aReport configureReportEvaluation: self reportEvaluationContext.
			aColumn configureReportEvaluation: self reportEvaluationContext.
			aReport totalizadores do: [ :aTotal | aReport reportResult saveTotalValueOf: aTotal forColumn: aColumn inEvaluationContext: self reportEvaluationContext ].
			aColumn cleanAfterReportEvaluation ]! !

!GRIDGroupOfReportSubjects methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 07/16/2012 19:03'!
rowsToPrint: aGRIDReport 
	^aGRIDReport reportResult reportSubjects! !

!GRIDGroupOfReportSubjects methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 07/04/2012 15:38'!
willProcessNextColumn
	"Hook up method to let subclasses do things before the next column is processed, such as commits, cache refreshing, etc"! !

Object subclass: #GRIDNullCellResult
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Core'!

!GRIDNullCellResult methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/1/2011 15:25'!
description
	^''! !

!GRIDNullCellResult methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 08/01/2012 15:15'!
hasNumericCurrencyResult
	^false! !

!GRIDNullCellResult methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 07/04/2012 19:49'!
label
	^'' ! !

!GRIDNullCellResult methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 09:32'!
resultFor: aGRIDReportEvaluationContext 
	^nil! !

Object subclass: #GRIDNullCellValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Core'!

GRIDNullCellValue class
	instanceVariableNames: 'uniqueInstance'!

GRIDNullCellValue class
	instanceVariableNames: 'uniqueInstance'!

!GRIDNullCellValue class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 6/18/2012 17:22'!
uniqueInstance 
	^uniqueInstance ifNil:[uniqueInstance := self new]! !

!GRIDNullCellValue methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 08/22/2012 19:34'!
asCurrencyString
	^''! !

!GRIDNullCellValue methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/6/2012 20:46'!
asString 
	^''! !

!GRIDNullCellValue methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/6/2012 00:49'!
isNullCellValue
	^true! !

Object subclass: #GRIDNullConfigurationValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Core'!

!GRIDNullConfigurationValue methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/6/2012 20:46'!
asString 
	^'N/A'! !

!GRIDNullConfigurationValue methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/6/2012 01:33'!
seasideString 
	^'N/A'! !

!GRIDNullConfigurationValue methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/1/2011 17:35'!
titleInReport 
	^'N/A'! !

Object subclass: #GRIDNullDate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Core'!

!GRIDNullDate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/10/2012 15:57'!
< otherObject
	^true! !

!GRIDNullDate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/10/2012 15:54'!
> otherObject
	^false! !

!GRIDNullDate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/10/2012 15:58'!
asDate
	! !

!GRIDNullDate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/10/2012 15:54'!
asString
	^''! !

Object subclass: #GRIDNullReport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Core'!

!GRIDNullReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/1/2011 15:19'!
autoGeneratedTitle
	^'Title'! !

!GRIDNullReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/18/2011 14:07'!
configurations
	^#()! !

!GRIDNullReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/27/2012 16:36'!
reportResult
	^GRIDFactory currentFactory newReportResult ! !

Object subclass: #GRIDReport
	instanceVariableNames: 'columnas evaluable titulo descripcion totalizadores notas configuraciones grupoDeSujetosDeEvaluacion esModelo erroresDeUltimoProceso fechaDeCreacion reportResult fechaDeUltimaEvaluacion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Core'!

GRIDReport class
	instanceVariableNames: 'scheduler'!

GRIDReport class
	instanceVariableNames: 'scheduler'!

!GRIDReport class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/5/2012 17:29'!
scheduler 
	^scheduler ifNil:[GRIDReportEvaluationScheduler uniqueInstance ]! !

!GRIDReport class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/5/2012 15:42'!
scheduler: aScheduler 
	scheduler := aScheduler ! !

!GRIDReport methodsFor: 'orden de columnas' stamp: 'carlaGriggio 11/21/2011 13:42'!
acomodar: unaColumna enOrden: unIndice
|posicionOriginal|
	posicionOriginal:= self reportColumns indexOf: unaColumna.
	(posicionOriginal = unIndice) ifFalse:[
		self reportColumns at: posicionOriginal put: #auxiliar.
		(unIndice < self reportColumns size) ifTrue:[
		self reportColumns add: unaColumna beforeIndex: unIndice+1]
		ifFalse:[self addColumn: unaColumna ].
		
		self reportColumns remove: #auxiliar.
		]! !

!GRIDReport methodsFor: 'totalizadores' stamp: 'carlaGriggio 11/21/2011 13:44'!
addAggregation: unTotalizador
	(self totalizadores includes: unTotalizador) 
		ifFalse:[ self totalizadores add: unTotalizador ]! !

!GRIDReport methodsFor: 'accessing' stamp: 'carlaGriggio 11/21/2011 13:43'!
addColumn: aReportColumn 
	self reportColumns add: aReportColumn  ! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/10/2011 12:16'!
addConfiguration: aConfiguration
	self configurations add: aConfiguration
! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 16:57'!
addConfigurationOfClass: aConfigurationClass
	self configurations add: aConfigurationClass new
! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'mdc 07/18/2011 18:31'!
addError: unError
 	erroresDeUltimoProceso add: unError ! !

!GRIDReport methodsFor: 'notas' stamp: 'carlaGriggio 2/16/2012 17:16'!
addNote: unaNota
	(self includesNote: unaNota) ifFalse:[ self notes add: unaNota]! !

!GRIDReport methodsFor: 'orden de columnas' stamp: 'carlaGriggio 10/6/2011 17:54'!
adelantarColumna: unaColumna
	self acomodar: unaColumna  enOrden: (self reportColumns indexOf: unaColumna ) +1! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/1/2011 16:16'!
allConfigurations
	^self configurations union: (self reportColumns inject: Set new into:[:columnConfigurations :column | columnConfigurations union: column configurations])! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/12/2012 18:31'!
asString 
	^self reportTitle! !

!GRIDReport methodsFor: 'orden de columnas' stamp: 'carlaGriggio 10/6/2011 17:54'!
atrasarColumna: unaColumna
	self acomodar: unaColumna  enOrden: (self reportColumns indexOf: unaColumna ) -2! !

!GRIDReport methodsFor: 'accessing' stamp: 'carlaGriggio 8/27/2012 17:10'!
autoGeneratedTitle
	^((self configurations asSortedCollection: [:conf1 :conf2 | conf1 orderInReportTitle < conf2 orderInReportTitle ])   inject: '' into:[:tituloDescriptivo :conf | tituloDescriptivo , ' ', conf titleInReport   ]) trimLeft! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 6/2/2011 16:44'!
beInformeModelo 
	esModelo := true! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 6/2/2011 16:44'!
beInformeNormal 
	esModelo := false! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 08/08/2012 12:44'!
calculate
	"Este mtodo se suele ejecutar fuera de Seaside"
	[
	self resetErroresDeUltimoProceso.
	self resetReportResult.
	self groupOfReportSubjects calculateReportValuesOf: self.  
	fechaDeUltimaEvaluacion := DateAndTime now ] on: 
	Error do:[:error |   
		self addError: error. 
		fechaDeUltimaEvaluacion := DateAndTime now.
"		GRIDReport scheduler terminarProcesoYPasarAlSiguiente.
		SueldoModel resetSessionMock.
		error signal"].
! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/27/2012 16:28'!
cancelarProceso
	GRIDFactory currentFactory reportEvaluationScheduler cancelarProcesoDeInformeYprocesarSiguiente: self ! !

!GRIDReport methodsFor: 'accessing' stamp: 'carlaGriggio 8/7/2011 21:05'!
cantidadSujetosDeEvaluacion
	^self reportSubjects size! !

!GRIDReport methodsFor: 'accessing' stamp: 'carlaGriggio 5/28/2012 17:32'!
cellResult
	^ (self configurations detect:[:conf | (conf isKindOf: GRIDCellResultConfiguration )]) cellResult ! !

!GRIDReport methodsFor: 'accessing' stamp: 'carlaGriggio 8/25/2011 14:38'!
cellResult: anObject
	evaluable := anObject! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/13/2011 21:53'!
cellResultConfiguration
	^self configurations detect:[:conf | conf isKindOf:  GRIDCellResultConfiguration] ifNone:[nil]
! !

!GRIDReport methodsFor: 'evaluacion' stamp: 'carlaGriggio 8/25/2011 15:24'!
cleanAfterReportEvaluation
	self configurations do:[:conf | conf cleanAfterReportEvaluation ].! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 5/20/2011 14:48'!
configuraciones: unasConfiguraciones
	configuraciones := unasConfiguraciones ! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 14:25'!
configurarTipoDeEvaluacion
	! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/20/2011 21:10'!
configurations
	^configuraciones ifNil:[configuraciones := Set new]! !

!GRIDReport methodsFor: 'evaluacion' stamp: 'carlaGriggio 10/13/2011 20:59'!
configureReportEvaluation: aReportEvaluationContext
	self configurations do:[:conf | conf configureReportEvaluation: aReportEvaluationContext ]! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/27/2012 16:31'!
delete
	GRIDFactory currentFactory reportRepository removeInforme: self! !

!GRIDReport methodsFor: 'accessing' stamp: 'carlaGriggio 10/13/2011 21:51'!
description
	^ descripcion! !

!GRIDReport methodsFor: 'accessing' stamp: 'carlaGriggio 7/6/2012 19:54'!
description: anObject
	descripcion := anObject! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/12/2012 18:31'!
displayString 
self deprecated: 'Usar asString'.
	^self reportTitle! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'mdc 07/18/2011 18:28'!
erroresDeUltimoProceso 
  	erroresDeUltimoProceso ifNil:[self resetErroresDeUltimoProceso ].
	^erroresDeUltimoProceso! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 6/2/2011 16:32'!
esInformeModelo
	^esModelo ifNil:[false]! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/27/2012 16:28'!
estaEnEsperaDeProceso
	^GRIDFactory currentFactory reportEvaluationScheduler estaEnEsperaDeProceso: self! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/27/2012 16:28'!
estaEnProceso
	^GRIDFactory currentFactory reportEvaluationScheduler estaEnProceso: self! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 08/22/2012 19:05'!
estaProcesado
	^"self fechaDeUltimaEvaluacion notNil and:[self fechaDeUltimaEvaluacion > self fechaDeCreacion]"
	self reportResult isEmptyResult not! !

!GRIDReport methodsFor: 'fechas' stamp: 'carlaGriggio 8/25/2011 16:50'!
fechaDeCreacion 
	^fechaDeCreacion ifNil:[DateAndTime epoch ]! !

!GRIDReport methodsFor: 'fechas' stamp: 'carlaGriggio 7/10/2012 15:55'!
fechaDeUltimaEvaluacion
	^fechaDeUltimaEvaluacion ifNil:[GRIDNullDate new]! !

!GRIDReport methodsFor: 'fechas' stamp: 'carlaGriggio 7/10/2012 15:57'!
fechaDeUltimoCambioOProceso
	^self fechaDeCreacion max: self fechaDeUltimaEvaluacion ! !

!GRIDReport methodsFor: 'accessing' stamp: 'carlaGriggio 8/7/2011 21:01'!
groupOfReportSubjects
	^ grupoDeSujetosDeEvaluacion! !

!GRIDReport methodsFor: 'accessing' stamp: 'carlaGriggio 10/21/2011 11:35'!
groupOfReportSubjects: anObject
	grupoDeSujetosDeEvaluacion := anObject! !

!GRIDReport methodsFor: 'testing' stamp: 'carlaGriggio 10/7/2011 17:22'!
hasResolvedAllCellValues
	^self reportResult hasResolvedAllCellValues ! !

!GRIDReport methodsFor: 'testing' stamp: 'carlaGriggio 11/18/2011 14:11'!
includesColumnWithConfigurationOfClass: aConfigurationClass 
	^self reportColumns anySatisfy:  [:column | column includesConfigurationOfClass:  aConfigurationClass   ]! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/1/2011 15:16'!
includesConfiguration: aConfigurationOfCourse 
	self shouldBeImplemented.! !

!GRIDReport methodsFor: 'testing' stamp: 'carlaGriggio 11/18/2011 13:19'!
includesConfigurationOfClass: aConfigurationClass 
	^self configurations anySatisfy:  [:conf | conf class = aConfigurationClass ] ! !

!GRIDReport methodsFor: 'notas' stamp: 'carlaGriggio 2/16/2012 17:16'!
includesNote: unaNota
	^self notes includes: unaNota! !

!GRIDReport methodsFor: 'notas' stamp: 'carlaGriggio 2/16/2012 17:16'!
indiceDeNota: unaNota
	^'(', (self notes indexOf: unaNota) asString ,')'! !

!GRIDReport methodsFor: 'fechas' stamp: 'carlaGriggio 7/10/2012 15:51'!
lastModificationDate
	^self fechaDeCreacion asDate! !

!GRIDReport methodsFor: 'fechas' stamp: 'carlaGriggio 07/24/2012 20:01'!
lastModificationDate: aDateAndTime
	fechaDeCreacion := aDateAndTime! !

!GRIDReport methodsFor: 'fechas' stamp: 'carlaGriggio 7/10/2012 15:49'!
lastProcessDate
	^self fechaDeUltimaEvaluacion ifNotNil:[self fechaDeUltimaEvaluacion asDate]! !

!GRIDReport methodsFor: 'notas' stamp: 'carlaGriggio 2/16/2012 17:16'!
notasParaProvincia: unaProvincia
	^(self notes select:[:nota | nota afectaProvincia: unaProvincia ])! !

!GRIDReport methodsFor: 'notas' stamp: 'carlaGriggio 2/16/2012 17:16'!
notes
	^notas ifNil:[notas := OrderedCollection new]! !

!GRIDReport methodsFor: 'notas' stamp: 'carlaGriggio 2/16/2012 17:17'!
notes: someNotes
	notas :=someNotes ! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 2/14/2012 17:55'!
printString
	^super printString, ' (', self reportTitle, ')'! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/27/2012 16:27'!
process
	GRIDFactory currentFactory reportEvaluationScheduler encolarInforme: self .
	"self calculate "
! !

!GRIDReport methodsFor: 'totalizadores' stamp: 'carlaGriggio 8/7/2011 21:07'!
promediosPonderados 
	^self totalizadores select:[:tot | tot isKindOf: PonderatedAverageAgregation  ]
	! !

!GRIDReport methodsFor: 'accessing' stamp: 'carlaGriggio 10/6/2011 17:54'!
removeColumna: aColumnaDeInforme 
	self reportColumns remove: aColumnaDeInforme ! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/20/2011 21:19'!
removeConfigurations
	self configurations removeAll.! !

!GRIDReport methodsFor: 'notas' stamp: 'carlaGriggio 07/31/2012 12:02'!
removeNote: unaNota
	(self includesNote: unaNota) ifTrue:[ self notes remove: unaNota]! !

!GRIDReport methodsFor: 'totalizadores' stamp: 'cfg 5/20/2010 11:56'!
removeTotalizador: unTotalizador
	(self totalizadores includes: unTotalizador) 
		ifTrue:[ self totalizadores remove: unTotalizador ]! !

!GRIDReport methodsFor: 'accessing' stamp: 'carlaGriggio 10/6/2011 17:54'!
reportColumns
	^ columnas ifNil:[columnas:= OrderedCollection new]! !

!GRIDReport methodsFor: 'accessing' stamp: 'carlaGriggio 10/6/2011 17:55'!
reportColumns: unasColumnas
	columnas := unasColumnas ! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 08/22/2012 20:12'!
reportCopy
	| copia |
	copia := self copy.
	copia reportColumns: (self reportColumns collect:[:col | col copy]).
	copia totalizadores: (self totalizadores collect:[:tot | tot copy]).
	copia configuraciones: (self configurations collect:[:conf | conf copy]).
	copia groupOfReportSubjects: self groupOfReportSubjects copy initialize. 
	copia beInformeNormal.
	copia resetReportResult.
	^ copia! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 2/10/2012 17:00'!
reportFactory 
	^self cellResultConfiguration ifNotNil:[self cellResultConfiguration reportFactory] ifNil:[self reportColumns anyOne cellResultConfiguration reportFactory]! !

!GRIDReport methodsFor: 'accessing' stamp: 'carlaGriggio 10/7/2011 14:42'!
reportResult
	^reportResult! !

!GRIDReport methodsFor: 'accessing' stamp: 'carlaGriggio 8/7/2011 21:05'!
reportSubjects
	^ grupoDeSujetosDeEvaluacion reportSubjects ! !

!GRIDReport methodsFor: 'accessing' stamp: 'carlaGriggio 10/21/2011 19:42'!
reportTitle
	^ titulo! !

!GRIDReport methodsFor: 'accessing' stamp: 'carlaGriggio 10/21/2011 19:42'!
reportTitle: anObject
	titulo := anObject! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/8/2011 16:11'!
resetErroresDeUltimoProceso 
	erroresDeUltimoProceso := OrderedCollection new.! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/27/2012 16:36'!
resetReportResult
	reportResult := GRIDFactory currentFactory newReportResult.

	
	
	! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 07/16/2012 19:03'!
rowsToPrint
	^ grupoDeSujetosDeEvaluacion rowsToPrint: self! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/27/2012 16:31'!
save
	"self calcularValores."
	self resetReportResult.
	GRIDFactory currentFactory reportRepository addInforme: self.
	fechaDeCreacion := DateAndTime now.
	! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/7/2011 14:42'!
saveCellResult: aCellResult forColumn: aGRIDReportColumn andReportSubject: aReportSubject
	self reportResult saveCellResult: aCellResult forColumn: aGRIDReportColumn andReportSubject: aReportSubject ! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 08/22/2012 19:22'!
seProcesoCorrectamente
	^"self tieneValoresEvaluados and:["self erroresDeUltimoProceso isEmpty"]"! !

!GRIDReport methodsFor: 'totalizadores' stamp: 'carlaGriggio 8/25/2011 17:05'!
tieneTotalPorPromedio
	^self totalizadores anySatisfy:[:tot | tot isKindOf: AverageAgregation ]
	! !

!GRIDReport methodsFor: 'totalizadores' stamp: 'carlaGriggio 8/25/2011 17:05'!
tieneTotalPorSumatoria
	^self totalizadores anySatisfy:[:tot | tot isKindOf: SumatoryAgregation]! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/7/2011 15:25'!
tieneValoresEvaluados
	^self reportResult hasResolvedAllCellValues ! !

!GRIDReport methodsFor: 'totalizadores' stamp: 'cfg 5/17/2010 13:03'!
totalizadores
	^totalizadores ifNil:[totalizadores := OrderedCollection new]! !

!GRIDReport methodsFor: 'totalizadores' stamp: 'cfg 5/20/2010 14:56'!
totalizadores: unosTotalizadores
	totalizadores := unosTotalizadores! !

!GRIDReport methodsFor: 'as yet unclassified' stamp: 'cfg 5/20/2010 15:08'!
usaTablaDePonderacion: unaTabla
	^self promediosPonderados anySatisfy: [:prom | prom tablaPonderacion = unaTabla ]! !

Object subclass: #GRIDReportBuilder
	instanceVariableNames: 'grupoDeSujetosDeEvaluacion reportFactory reportColumns columnConfigurations reportConfigurations editedTitle notes aggregations reportDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Core'!

!GRIDReportBuilder class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/11/2012 10:14'!
fromReport: aReport
	^self new
"		report: (GRIDReport new reportTitle: aReport reportTitle);"
		reportColumns:  (aReport  reportColumns collect:[:col | col copy]);
		reportDescription:  aReport  description ;
		reportFactory:   aReport  reportFactory;
		notes: aReport notes;
		extractConfigurationsFrom: aReport;
		extractAggregationsFrom: aReport;
		editedTitleFromReportTitle: aReport  reportTitle.! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/18/2011 13:52'!
addColumnConfigurationOfClass: aGRIDCellResultConfigurationClass
	columnConfigurations add: aGRIDCellResultConfigurationClass ! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/11/2011 19:36'!
addColumnConfigurationOfClass: aGRIDCellResultConfigurationClass toReportColumn: aReportColumn
	self addColumnConfigurationOfClass:  aGRIDCellResultConfigurationClass.
	aReportColumn addConfiguration:  (self newConfigurationOfClass:  aGRIDCellResultConfigurationClass  )! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 2/16/2012 17:15'!
addNote: aNote
	self notes add: aNote! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/14/2011 14:14'!
addReportColumn:  aReportColumn
	reportColumns add: aReportColumn ! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/18/2011 14:19'!
addReportConfigurationOfClass: aGRIDReportConfigurationClass 
	reportConfigurations add: (self newConfigurationOfClass:   aGRIDReportConfigurationClass)  ! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/10/2011 12:28'!
addToAllColumnsConfigurationOfClass: aGRIDCellResultConfiguration 
	columnConfigurations add:  (self newConfigurationOfClass:  aGRIDCellResultConfiguration).
	self reportColumns do:[:reportColumn | reportColumn addConfiguration:  (self newConfigurationOfClass:  aGRIDCellResultConfiguration)  ]! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 5/31/2012 18:20'!
aggregations
	^ aggregations! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/11/2011 19:51'!
allAvailableConfigurations
	^self availableReportConfigurations union: self availableColumnConfigurations ! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/21/2011 15:02'!
allReportColumnsAreAggregableBy:  anAggregation
	^ self reportColumns  allButFirst allSatisfy:  [:column | column isAgreggableBy:  anAggregation  ] ! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 2/14/2012 16:56'!
availableColumnConfigurations
	^self reportFactory possibleConfigurationsForColumns" copyWithoutAll: self columnConfigurations"  ! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 2/14/2012 16:56'!
availableReportConfigurations
	^self reportFactory possibleConfigurationsForReport" copyWithoutAll: self reportConfigurationClasses"! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 6/7/2012 18:01'!
basicAggregations
	^self reportFactory basicAggregations ! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 07/24/2012 20:02'!
build
|newReport|
	newReport := self newReport.
	reportConfigurations do:[:config |
		newReport addConfiguration: config ].
	reportFactory silentConfigurations do:[:configClass |
		newReport addConfiguration: (self newConfigurationOfClass:  configClass ) ].
	self reportColumns do:[:columna |
		newReport addColumn: columna
		].
	self aggregations do:[:agg |
		(self reportColumns anySatisfy:  [:column | column isAgreggableBy:  agg ])
			ifTrue:[newReport addAggregation:  agg ]  ].
	newReport notes: self notes.
	newReport groupOfReportSubjects: self groupOfReportSubjects.

	(self isValidReport: newReport)  ifFalse:[ReportCannotBeBuiltError signal].
	newReport reportTitle: (editedTitle ifNil:[newReport autoGeneratedTitle ]).
	newReport description:  self reportDescription . 
	newReport lastModificationDate: DateAndTime now.
	^newReport
	
	! !

!GRIDReportBuilder methodsFor: 'accessing' stamp: 'carlaGriggio 1/18/2012 00:40'!
buildColumns
	reportColumns := self reportFactory buildColumns: self columnsCount asNumber withConfigurations: self columnConfigurations.! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/10/2011 12:22'!
columnConfigurations
	^ columnConfigurations ! !

!GRIDReportBuilder methodsFor: 'accessing' stamp: 'carlaGriggio 7/11/2012 10:10'!
columnsCount
	^ 3! !

!GRIDReportBuilder methodsFor: 'accessing' stamp: 'carlaGriggio 7/6/2012 00:34'!
editedTitle 
	^editedTitle! !

!GRIDReportBuilder methodsFor: 'accessing' stamp: 'carlaGriggio 2/14/2012 17:25'!
editedTitle: aString
	editedTitle := aString ! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/6/2012 01:25'!
editedTitleFromReportTitle: aTitle
	(aTitle = self mockReport autoGeneratedTitle) ifFalse: [self editedTitle:  aTitle  ] ! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 6/7/2012 18:18'!
extractAggregationsFrom: aGRIDReport 
	|extractedAggs|
	extractedAggs   := (aGRIDReport reportColumns inject: Set new into:[:aggs :column | aggs union: column allowedAggregations]).
	aggregations   := reportFactory  basicAggregations union: (extractedAggs union: (self aggregations reject:[:agg | extractedAggs anySatisfy: [:aggr | aggr isKindOf: agg class] ]))  .! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 5/28/2012 19:41'!
extractConfigurationsFrom: aGRIDReport 
	reportConfigurations := (aGRIDReport configurations reject:[:conf | reportFactory silentConfigurations anySatisfy:  [:config | conf isKindOf:  config ]] ).
	columnConfigurations := (aGRIDReport reportColumns inject: Set new into:[:configs :column | configs union: (column configurations collect:[:conf | conf class])]) collect:[:configClass | configClass new].
! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/7/2011 21:01'!
groupOfReportSubjects 
	^grupoDeSujetosDeEvaluacion ! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 2/16/2012 17:15'!
includesNote: aNote
	^self notes includes: aNote! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/11/2012 10:08'!
initialize
	columnConfigurations := OrderedCollection new.
	reportConfigurations := OrderedCollection new.
! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 6/11/2012 20:23'!
isValidReport: aReport
	^(reportFactory mandatoryReportConfigurations allSatisfy:[:conf |
		(aReport includesConfigurationOfClass: conf ) or: 
		[aReport includesColumnWithConfigurationOfClass: conf ].
		] ) and: [
			aReport allConfigurations noneSatisfy: [:conf | conf notSet] ].
! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 08/21/2012 12:30'!
mockReport
	"A report that is built to get 3 examples of what the results will look like"
	|mockReport logEntry continuation|
	[mockReport := self build.
	mockReport groupOfReportSubjects: (self groupOfReportSubjects copy maximumSizeOfReportSubjects:  3).
	mockReport calculate.
	^mockReport ] on: Error  do:[:anException | 
		"WAGemStoneProductionErrorHandler new saveExceptionContinuation: anException."
	^GRIDNullReport new]! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/10/2011 12:08'!
newConfigurationOfClass: aGRIDCellResultConfigurationClass
^ aGRIDCellResultConfigurationClass new reportFactory: self reportFactory  . ! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/27/2012 16:37'!
newReport
	^GRIDFactory currentFactory reportClass new! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/11/2011 19:38'!
nombreDeModelo: unNombre
	self report reportTitle:  unNombre ! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 2/23/2012 15:25'!
notes
	^notes ifNil:[notes := OrderedCollection new]! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 2/16/2012 17:16'!
notes: someNotes
	notes := someNotes ! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/18/2012 09:31'!
preBuild
|textoConfigsFaltantes configsOrdenadas|
	self buildColumns.
	"Se hace esto en vez de agregarlas directamente por si el usuario retrocedi en el armado del informe y vuelve a hacer preBuild"
		self reportFactory fixedConfigurations do:[:fixedConfigurationClass |
		(reportConfigurations anySatisfy:[:conf | conf isKindOf: fixedConfigurationClass]) ifFalse:[self addReportConfigurationOfClass:  fixedConfigurationClass.]
		].
		! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 2/13/2012 18:41'!
removeConfiguration:  aConfiguration fromColumn:  aReportColumn
	aReportColumn removeConfiguration:  aConfiguration.
	(reportColumns noneSatisfy:  [:column | column includesConfigurationOfClass:  aConfiguration  class]) ifTrue:[columnConfigurations remove: aConfiguration class ifAbsent:[]  ]! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/18/2011 14:17'!
removeConfigurationFromReport:  aConfiguration
	reportConfigurations remove: aConfiguration! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 2/16/2012 17:15'!
removeNote: aNote
	self notes remove: aNote! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/18/2011 13:02'!
removeReportColumn:  aReportColumn
	reportColumns remove: aReportColumn ! !

!GRIDReportBuilder methodsFor: 'accessing' stamp: 'carlaGriggio 11/10/2011 12:21'!
reportColumns 
	^reportColumns ! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/10/2011 12:21'!
reportColumns: someReportColumns
	reportColumns := someReportColumns ! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/18/2011 14:18'!
reportConfigurationClasses
	^(reportConfigurations collect:[:conf | conf class]) asSet! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/18/2011 14:17'!
reportConfigurations
	^reportConfigurations! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/6/2012 20:03'!
reportDescription 
	^reportDescription ! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/6/2012 20:03'!
reportDescription: aString
	reportDescription :=  aString ! !

!GRIDReportBuilder methodsFor: 'accessing' stamp: 'carlaGriggio 10/17/2011 15:19'!
reportFactory
	^ reportFactory! !

!GRIDReportBuilder methodsFor: 'accessing' stamp: 'carlaGriggio 5/31/2012 18:22'!
reportFactory: anObject
	reportFactory := anObject.
	grupoDeSujetosDeEvaluacion := reportFactory groupOfReportSubjects.
	aggregations := reportFactory aggregations ! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 2/14/2012 17:56'!
resetEditedTitle 
	self editedTitle:  nil ! !

!GRIDReportBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/21/2011 14:24'!
toggleAllReportColumnsAggregation: anAggregation
	(self allReportColumnsAreAggregableBy: anAggregation)
		ifTrue: [ self reportColumns allButFirst do: [ :column | column disallowAggregation: anAggregation ] ]
		ifFalse: [ self reportColumns allButFirst do: [ :column | column allowAggregation: anAggregation ] ]! !

Object subclass: #GRIDReportColumn
	instanceVariableNames: 'claseCssCelda claseCssEncabezado informe configuraciones allowedAggregations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Core'!

!GRIDReportColumn class methodsFor: 'as yet unclassified' stamp: 'CarlaGriggio 06/13/2011 13:05'!
conConfiguraciones: unasConfiguraciones
	^self new configuraciones: unasConfiguraciones! !

!GRIDReportColumn methodsFor: 'css' stamp: 'cfg 5/3/2010 15:50'!
aLaDerecha
	self claseCssEncabezado: 'derecha'.
	self claseCssCelda: 'derecha'! !

!GRIDReportColumn methodsFor: 'css' stamp: 'cfg 5/3/2010 15:50'!
aLaIzquierda
	self claseCssEncabezado: 'izquierda'.
	self claseCssCelda: 'izquierda'! !

!GRIDReportColumn methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/10/2011 12:17'!
addConfiguration: aConfiguration
	(self configurations anySatisfy:  [:conf | conf isKindOf:  aConfiguration class]) ifFalse:[self configurations add: aConfiguration]! !

!GRIDReportColumn methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 5/31/2012 17:49'!
allowAggregation: anAggregation
	allowedAggregations add: anAggregation ! !

!GRIDReportColumn methodsFor: 'accessing' stamp: 'carlaGriggio 11/21/2011 13:40'!
allowedAggregations
	^ allowedAggregations ifNil:[allowedAggregations := Set new]! !

!GRIDReportColumn methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/21/2011 17:10'!
allowedAggregations: someAggregations
	allowedAggregations := someAggregations ! !

!GRIDReportColumn methodsFor: 'as yet unclassified' stamp: 'CarlaGriggio 06/06/2011 20:47'!
borrarCacheDeColumna
	valoresGuardados := Dictionary new.
	valoresGuardadosDeTotalizadores := Dictionary new.! !

!GRIDReportColumn methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 5/28/2012 17:31'!
cellResult 
	^(self configurations detect:[:conf | (conf isKindOf: GRIDCellResultConfiguration )] ifNone:[ informe ]) cellResult  ! !

!GRIDReportColumn methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 14:22'!
cellResultConfiguration
	^self configurations detect:[:conf | conf isKindOf:  GRIDCellResultConfiguration]

! !

!GRIDReportColumn methodsFor: 'evaluating' stamp: 'carlaGriggio 07/31/2012 16:00'!
cellValueForReportData: aReportEvaluationContext 
	|cellValue|
		self configureReportEvaluation: aReportEvaluationContext .
		cellValue:= aReportEvaluationContext cellResultValue.
		cellValue ifNil:[NullCellValueError signal ].
		self cleanAfterReportEvaluation.
	^cellValue
! !

!GRIDReportColumn methodsFor: 'css' stamp: 'cfg 5/3/2010 15:50'!
centrada
	self claseCssEncabezado: 'centrado'.
	self claseCssCelda: 'centrado'! !

!GRIDReportColumn methodsFor: 'css' stamp: 'cfg 5/3/2010 15:50'!
centradoDerecha
	self claseCssCelda: 'derecha'.
	self claseCssEncabezado: 'centrado'.! !

!GRIDReportColumn methodsFor: 'css' stamp: 'cfg 5/3/2010 15:51'!
centradoIzquierda
	self claseCssCelda: 'izquierda'.
	self claseCssEncabezado: 'centrado'.! !

!GRIDReportColumn methodsFor: 'as yet unclassified' stamp: 'cfg 5/3/2010 15:52'!
claseCss: unaClaseCss
	self claseCssCelda: unaClaseCss.
	self claseCssEncabezado: unaClaseCss ! !

!GRIDReportColumn methodsFor: 'css' stamp: 'cfg 5/3/2010 15:25'!
claseCssCelda
	^ claseCssCelda ifNil:['']! !

!GRIDReportColumn methodsFor: 'css' stamp: 'cfg 5/3/2010 15:19'!
claseCssCelda: anObject
	claseCssCelda := anObject! !

!GRIDReportColumn methodsFor: 'css' stamp: 'cfg 5/3/2010 15:25'!
claseCssEncabezado
	^ claseCssEncabezado ifNil:['']! !

!GRIDReportColumn methodsFor: 'css' stamp: 'cfg 5/3/2010 15:19'!
claseCssEncabezado: anObject
	claseCssEncabezado := anObject! !

!GRIDReportColumn methodsFor: 'configuraciones' stamp: 'carlaGriggio 8/25/2011 14:22'!
cleanAfterReportEvaluation
	self configurations do:[:conf | conf cleanAfterReportEvaluation ]! !

!GRIDReportColumn methodsFor: 'configuraciones' stamp: 'carlaGriggio 07/04/2012 22:05'!
columnTitle 
|subTitles|
self configurations ifNotEmpty:[
subTitles := (self configurations collect:[:conf | conf titleInReport]) asSet remove:'' ifAbsent:[]; asOrderedCollection.
subTitles ifEmpty:[^''].
^subTitles  allButFirst inject: subTitles first into:[:tit :subTitle | subTitle ifNotEmpty:[tit asString, ' - ', subTitle] ifEmpty:[tit]] ]
ifEmpty:[^''] 
! !

!GRIDReportColumn methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 5/20/2011 14:48'!
configuraciones: unasConfiguraciones
	configuraciones := unasConfiguraciones ! !

!GRIDReportColumn methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 14:22'!
configurations 
	^configuraciones ! !

!GRIDReportColumn methodsFor: 'configuraciones' stamp: 'carlaGriggio 6/18/2012 16:44'!
configureReportEvaluation: aReportEvaluationContext
"	self configurations ifEmpty:[ aReportEvaluationContext cleanColumnConfigurations]."
	self configurations do:[:conf | conf configureReportEvaluation: aReportEvaluationContext ]! !

!GRIDReportColumn methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/21/2011 17:09'!
copy
	| newColumn |
	newColumn := super copy.
	newColumn configuraciones: (self configurations collect:[:conf | conf copy]  ).  
	newColumn allowedAggregations: (self allowedAggregations copy).
	^ newColumn! !

!GRIDReportColumn methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/21/2011 13:34'!
disallowAggregation: anAggregation
	allowedAggregations remove: anAggregation ! !

!GRIDReportColumn methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/7/2011 14:18'!
hasNumericCurrencyResult
	^self cellResult hasNumericCurrencyResult! !

!GRIDReportColumn methodsFor: 'testing' stamp: 'carlaGriggio 11/18/2011 13:19'!
includesConfigurationOfClass: aConfigurationClass 
	^self configurations  anySatisfy:  [:conf | conf class = aConfigurationClass ] ! !

!GRIDReportColumn methodsFor: 'as yet unclassified' stamp: 'CarlaGriggio 06/25/2010 13:02'!
informe: unInforme
	informe:= unInforme! !

!GRIDReportColumn methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/18/2011 17:12'!
initialize
	configuraciones := OrderedCollection new.
	allowedAggregations := Set new.! !

!GRIDReportColumn methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 07/31/2012 11:06'!
isAgreggableBy:  aTotal
	^ (self allowedAggregations includes: aTotal) "and:[[self cellResult isAggregable] on:Error do:[:error | false
			]]"! !

!GRIDReportColumn methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 14:22'!
removeConfiguracion: unaConfiguracionDeInforme
	self configurations remove: unaConfiguracionDeInforme ! !

!GRIDReportColumn methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 14:22'!
removeConfiguraciones 
	self configurations removeAll: self configurations.! !

!GRIDReportColumn methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/18/2011 13:09'!
removeConfiguration:  aConfiguration
	configuraciones  remove: aConfiguration ! !

!GRIDReportColumn methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/20/2011 21:19'!
removeConfigurations
	self configurations removeAll.! !

!GRIDReportColumn methodsFor: 'accessing' stamp: 'carlaGriggio 11/11/2011 19:38'!
report
	^ informe! !

!GRIDReportColumn methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/24/2011 13:33'!
sizeOfConfigurations 
	^self configurations size! !

!GRIDReportColumn methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/21/2011 13:37'!
toggleAggregation: anAggregation
	(self isAgreggableBy:  anAggregation)
		ifTrue:[self disallowAggregation:  anAggregation  ]
		ifFalse:[self allowAggregation:  anAggregation  ]   ! !

Object subclass: #GRIDReportConfiguration
	instanceVariableNames: 'configurationValue reportFactory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Core'!

GRIDReportConfiguration subclass: #GRIDCellResultConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Core'!

!GRIDCellResultConfiguration class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/13/2011 21:51'!
description
	^'Cell Result'! !

!GRIDCellResultConfiguration methodsFor: 'accessing' stamp: 'carlaGriggio 11/1/2011 16:07'!
cellResult
	^ self configurationValue ! !

!GRIDCellResultConfiguration methodsFor: 'accessing' stamp: 'carlaGriggio 11/1/2011 16:08'!
cellResult: aCellResult
	self configurationValue: aCellResult ! !

!GRIDCellResultConfiguration methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/13/2011 21:02'!
configureReportEvaluation:  aReportEvaluationContext
	aReportEvaluationContext cellResult: self cellResult  ! !

!GRIDCellResultConfiguration methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 6/11/2012 21:00'!
formInput 
|campo|
	campo:=(GRIDFMCombobox 
		label: 'Cell Result'
		description: '' 
		on: #cellResult  
		of: self)
			list: (self reportFactory possibleCellResults asSet );
			labels:[:s | s ifNotNil:[s label ]].
	^campo! !

!GRIDCellResultConfiguration methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/5/2012 19:56'!
initialize 
	self cellResult: GRIDNullCellResult new! !

!GRIDCellResultConfiguration methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 07/24/2012 20:47'!
titleInReport
	^self cellResult description ! !

!GRIDReportConfiguration methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/11/2012 11:27'!
asString
	^self description ,': ', self configurationValue asString ! !

!GRIDReportConfiguration methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 10:47'!
cleanAfterReportEvaluation 
	! !

!GRIDReportConfiguration methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/1/2011 16:05'!
configurationAspect
	^self subclassResponsibility ! !

!GRIDReportConfiguration methodsFor: 'accessing' stamp: 'carlaGriggio 11/1/2011 15:44'!
configurationValue
	^ configurationValue! !

!GRIDReportConfiguration methodsFor: 'accessing' stamp: 'carlaGriggio 11/1/2011 15:44'!
configurationValue: anObject
	configurationValue := anObject! !

!GRIDReportConfiguration methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/11/2012 11:36'!
configurationValueDetails
	^self configurationValue asString ! !

!GRIDReportConfiguration methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 5/21/2012 14:54'!
configureReportEvaluation: aReportEvaluationContext
	aReportEvaluationContext valueForConcern: self configurationAspect is: self configurationValue.
	! !

!GRIDReportConfiguration methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/13/2011 21:51'!
description
	^self class description! !

!GRIDReportConfiguration methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/1/2011 16:11'!
initialize
	super initialize.
	self configurationValue: GRIDNullConfigurationValue new ! !

!GRIDReportConfiguration methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/1/2011 16:13'!
notSet
	^self configurationValue isNil or:[self configurationValue isKindOf:  GRIDNullConfigurationValue  ] 
	! !

!GRIDReportConfiguration methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/7/2011 23:38'!
orderInReportTitle
	^10! !

!GRIDReportConfiguration methodsFor: 'accessing' stamp: 'carlaGriggio 11/10/2011 12:06'!
reportFactory
	^ reportFactory! !

!GRIDReportConfiguration methodsFor: 'accessing' stamp: 'carlaGriggio 11/10/2011 12:07'!
reportFactory: anObject
	reportFactory := anObject! !

!GRIDReportConfiguration methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 5/18/2012 20:07'!
session
	^WACurrentSession value! !

Object subclass: #GRIDReportEvaluationContext
	instanceVariableNames: 'reportConfigurationInfo report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Core'!

!GRIDReportEvaluationContext methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 09:21'!
cellResult
	^self valueForConcern: #cellResult! !

!GRIDReportEvaluationContext methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 09:21'!
cellResult: aCellResult
	self valueForConcern: #cellResult is: aCellResult! !

!GRIDReportEvaluationContext methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 08/21/2012 15:57'!
cellResultValue
	^"["self cellResult resultFor: self"] on: Error do:[:error | WAGemStoneProductionErrorHandler new saveExceptionContinuation: error. nil]"! !

!GRIDReportEvaluationContext methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/18/2011 14:33'!
cleanColumnConfigurations 
	self initialize.
	self report configureReportEvaluation:  self. ! !

!GRIDReportEvaluationContext methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/5/2012 19:55'!
initialize 
	reportConfigurationInfo := Dictionary new.
	self cellResult:  GRIDNullCellResult  new.! !

!GRIDReportEvaluationContext methodsFor: 'accessing' stamp: 'carlaGriggio 8/25/2011 14:26'!
report
	^ report! !

!GRIDReportEvaluationContext methodsFor: 'accessing' stamp: 'carlaGriggio 8/25/2011 14:26'!
report: anObject
	report := anObject! !

!GRIDReportEvaluationContext methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/18/2012 00:16'!
valueForConcern: aKey
	^reportConfigurationInfo at: aKey ifAbsent:[nil]! !

!GRIDReportEvaluationContext methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 09:21'!
valueForConcern: aKey is: aValue
	^reportConfigurationInfo at: aKey put: aValue ! !

Object subclass: #GRIDReportEvaluationScheduler
	instanceVariableNames: 'colaDeInformesEnProceso'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Core'!

GRIDReportEvaluationScheduler class
	instanceVariableNames: 'instancia'!

GRIDReportEvaluationScheduler class
	instanceVariableNames: 'instancia'!

!GRIDReportEvaluationScheduler class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 10:31'!
uniqueInstance
	instancia ifNil:[instancia := self new].
	^instancia.! !

!GRIDReportEvaluationScheduler methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 08/22/2012 18:10'!
cancelarProcesoDeInforme: unInforme
	colaDeInformesEnProceso removeKey: unInforme ifAbsent:[].! !

!GRIDReportEvaluationScheduler methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/13/2012 01:06'!
cancelarProcesoDeInformeYprocesarSiguiente: unInforme
	self cancelarProcesoDeInforme:  unInforme .
	self procesarSiguiente.	! !

!GRIDReportEvaluationScheduler methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 08/22/2012 18:01'!
encolarInforme: unInforme
	colaDeInformesEnProceso at: unInforme put: self proximoIndice.
	self procesarSiguiente.! !

!GRIDReportEvaluationScheduler methodsFor: 'as yet unclassified' stamp: 'CarlaGriggio 07/26/2011 14:15'!
estaEnEsperaDeProceso: unInforme
	^colaDeInformesEnProceso includesKey: unInforme   ! !

!GRIDReportEvaluationScheduler methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 08/22/2012 18:07'!
estaEnProceso: unInforme
	^[self peek = unInforme] on: Error do:[:error | false]! !

!GRIDReportEvaluationScheduler methodsFor: 'as yet unclassified' stamp: 'CarlaGriggio 07/26/2011 14:22'!
indiceDe: unInforme
	^ self informesEnEspera at: unInforme! !

!GRIDReportEvaluationScheduler methodsFor: 'as yet unclassified' stamp: 'CarlaGriggio 07/26/2011 14:10'!
indices
	^colaDeInformesEnProceso values! !

!GRIDReportEvaluationScheduler methodsFor: 'as yet unclassified' stamp: 'CarlaGriggio 7/22/2011 20:38'!
informesEnEspera
	^colaDeInformesEnProceso ! !

!GRIDReportEvaluationScheduler methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 16:47'!
initialize 
	colaDeInformesEnProceso := Dictionary new. ! !

!GRIDReportEvaluationScheduler methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 08/22/2012 18:05'!
peek
	^ self informesEnEspera ifEmpty:[GRIDNoReportsToProcessError signal] ifNotEmpty:[self informesEnEspera keyAtValue: self primerIndice]! !

!GRIDReportEvaluationScheduler methodsFor: 'as yet unclassified' stamp: 'CarlaGriggio 07/26/2011 14:24'!
primerIndice
	^((self indices ifEmpty:[Set with: 0] ifNotEmpty:[self indices]) asSortedCollection:[:in1 :in2 | in1 < in2]) first! !

!GRIDReportEvaluationScheduler methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 08/22/2012 17:52'!
procesarSiguiente
	|myFile informeAProcesar|
	"El primero en la cola es el que se est procesando. Se hace pop para sacar a un informe que se asume que ya se proces"
	"Faltan mejoras teniendo en cuenta tiempos, por si algn proceso falla y nunca llega a mover la cola"
	"Este mensaje se enva desde el proceso topaz del proceso del informe, al terminar el proceso. Ver /home/glass/evaluarInforme.sh"
	colaDeInformesEnProceso ifEmpty:[^self].
	
	[informeAProcesar := self peek.
	informeAProcesar calculate. self terminarProcesoYPasarAlSiguiente. ] on: Error do:[:error | "simplemente, no hay informes en espera"]! !

!GRIDReportEvaluationScheduler methodsFor: 'as yet unclassified' stamp: 'CarlaGriggio 07/26/2011 14:24'!
proximoIndice
	^((self indices ifEmpty:[Set with: 0] ifNotEmpty:[self indices]) asSortedCollection:[:in1 :in2 | in1 < in2]) last +1 ! !

!GRIDReportEvaluationScheduler methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 08/22/2012 20:09'!
terminarProcesoYPasarAlSiguiente
	[self informesEnEspera removeKey: self peek ifAbsent:[].
	self procesarSiguiente.] on: Error do:[:error | "No hay procesos para pasar al siguiente"].! !

Object subclass: #GRIDReportFactory
	instanceVariableNames: 'possibleConfigurationsForReport possibleConfigurationsForColumns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Core'!

!GRIDReportFactory class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/27/2012 16:47'!
newBuilder
	^GRIDFactory currentFactory newBuilder reportFactory: self new.! !

!GRIDReportFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 6/7/2012 18:02'!
aggregations
	^ self basicAggregations ! !

!GRIDReportFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 6/7/2012 18:02'!
basicAggregations
	^ {SumatoryAgregation uniqueInstance . AverageAgregation uniqueInstance }! !

!GRIDReportFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/27/2012 16:35'!
buildColumns: unaCantidadDeColumnas withConfigurations:  unasConfiguraciones
	|columnasDeInforme|
	columnasDeInforme := OrderedCollection new.
	 (1 to: unaCantidadDeColumnas ) do:[:i | columnasDeInforme add: (GRIDFactory currentFactory reportColumnClass conConfiguraciones:( unasConfiguraciones collect:[:conf | conf copy]))].
	^columnasDeInforme ! !

!GRIDReportFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 2/14/2012 16:58'!
cellResultConfigurationClass
	^GRIDCellResultConfiguration! !

!GRIDReportFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/11/2011 20:03'!
isConfigurationOfColumnOnly: aConfigurationOfCourseClass 
	^ (self possibleConfigurationsForColumns includes: aConfigurationOfCourseClass) and:[(self possibleConfigurationsForReport includes:  aConfigurationOfCourseClass) not  ]! !

!GRIDReportFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/11/2011 20:04'!
isConfigurationOfReportOnly: aConfigurationOfCourseClass 
	^ (self possibleConfigurationsForReport includes: aConfigurationOfCourseClass) and:[(self possibleConfigurationsForColumns includes:  aConfigurationOfCourseClass) not  ]! !

!GRIDReportFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/13/2011 21:35'!
mandatoryReportConfigurations
	^#()! !

!GRIDReportFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/13/2011 21:49'!
possibleCellResults 
	^self class possibleCellResults! !

!GRIDReportFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/13/2011 21:48'!
possibleConfigurationsForColumns
	^self possibleConfigurationsForReport! !

!GRIDReportFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 2/14/2012 16:58'!
possibleConfigurationsForReport
	^{self cellResultConfigurationClass }! !

!GRIDReportFactory methodsFor: 'accessing' stamp: 'carlaGriggio 8/7/2011 21:05'!
reportSubjects
	^self subclassResponsibility ! !

Object subclass: #GRIDReportRepository
	instanceVariableNames: 'todosLosInformes'
	classVariableNames: 'uniqueInstance'
	poolDictionaries: ''
	category: 'GRID-Core'!

!GRIDReportRepository class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 6/1/2012 17:26'!
uniqueInstance
	
	uniqueInstance  ifNil:[uniqueInstance  := self new].
	^uniqueInstance ! !

!GRIDReportRepository methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 6/15/2012 03:07'!
addInforme: unInforme
	(self todosLosInformes includes: unInforme) ifFalse:[ self todosLosInformes add: unInforme ]! !

!GRIDReportRepository methodsFor: 'as yet unclassified' stamp: 'CarlaGriggio 7/22/2011 22:04'!
hayInformesEnProceso 
	^self informesEnProceso notEmpty ! !

!GRIDReportRepository methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/27/2012 16:27'!
informesEnProceso
	^GRIDFactory currentFactory reportEvaluationScheduler informesEnEspera keys asSortedCollection:[:inf1 :inf2 | 
		(GRIDFactory currentFactory reportEvaluationScheduler indiceDe: inf1) < (GRIDFactory currentFactory reportEvaluationScheduler indiceDe: inf2) ]! !

!GRIDReportRepository methodsFor: 'as yet unclassified' stamp: 'CarlaGriggio 07/25/2011 17:32'!
informesProcesados
	^self informesQueNoEstanEnProceso select:[:inf | inf estaProcesado]! !

!GRIDReportRepository methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 08/22/2012 17:48'!
informesQueNoEstanEnProceso
	^self todosLosInformes reject:[:inf | inf estaEnEsperaDeProceso]! !

!GRIDReportRepository methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 07/05/2012 14:32'!
informesQueNoEstanEnProcesoOrdenados
	^self ordenadosPorFecha: self informesQueNoEstanEnProceso! !

!GRIDReportRepository methodsFor: 'as yet unclassified' stamp: 'CarlaGriggio 07/25/2011 16:13'!
ordenadosPorFecha: unosInformes
	^((unosInformes select:[:inf | inf esInformeModelo]) asSortedCollection: [:inf1 :inf2 | inf1 fechaDeUltimoCambioOProceso > inf2 fechaDeUltimoCambioOProceso]) asOrderedCollection,
		((unosInformes reject:[:inf | inf esInformeModelo]) asSortedCollection: [:inf1 :inf2 | inf1 fechaDeUltimoCambioOProceso > inf2 fechaDeUltimoCambioOProceso])  
	! !

!GRIDReportRepository methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 2/14/2012 17:41'!
removeInforme: unInforme
	todosLosInformes remove: unInforme ifAbsent:[]! !

!GRIDReportRepository methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/20/2011 15:43'!
todosLosInformes
	^todosLosInformes ifNil:[todosLosInformes := Set new]! !

!GRIDReportRepository methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/20/2011 15:43'!
todosLosInformesOrdenados
	^self ordenadosPorFecha:  self todosLosInformes  ! !

!GRIDReportRepository methodsFor: 'as yet unclassified' stamp: 'CarlaGriggio 07/25/2011 16:09'!
ultimosInformesCreados
	^(self informesQueNoEstanEnProceso asSortedCollection: [:inf1 :inf2 | inf1 fechaDeCreacion > inf2 fechaDeCreacion]) asOrderedCollection first:5  ! !

!GRIDReportRepository methodsFor: 'as yet unclassified' stamp: 'CarlaGriggio 07/25/2011 17:31'!
ultimosInformesProcesados
	^(self informesProcesados asSortedCollection: [:inf1 :inf2 | inf1 fechaDeUltimaEvaluacion > inf2 fechaDeUltimaEvaluacion]) first:5  ! !

Object subclass: #GRIDReportResult
	instanceVariableNames: 'reportSubjects cellValues totalValues columnTitles reportColumns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Core'!

!GRIDReportResult methodsFor: 'accessing' stamp: 'carlaGriggio 08/21/2012 16:34'!
cellValueForColumn: aGRIDReportColumn andSubject: aReportSubject
	^ (self cellValuesInColumn:  aGRIDReportColumn ) at: aReportSubject ifAbsent:["(CellValueNotResolvedError new column: aGRIDReportColumn; reportSubject: aReportSubject) signal" nil]! !

!GRIDReportResult methodsFor: 'accessing' stamp: 'carlaGriggio 10/7/2011 14:18'!
cellValueToPrintForColumn: aGRIDReportColumn andSubject: aReportSubject
	^aGRIDReportColumn hasNumericCurrencyResult 
		ifTrue:[(self cellValueForColumn: aGRIDReportColumn andSubject: aReportSubject) asCurrencyString]
		ifFalse:[self cellValueForColumn: aGRIDReportColumn andSubject: aReportSubject] ! !

!GRIDReportResult methodsFor: 'accessing' stamp: 'carlaGriggio 10/7/2011 13:35'!
cellValues
	^ cellValues! !

!GRIDReportResult methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/10/2011 12:47'!
cellValuesInColumn: aGRIDReportColumn 
	cellValues at: aGRIDReportColumn ifAbsentPut: [Dictionary new].
	^cellValues at: aGRIDReportColumn! !

!GRIDReportResult methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/11/2011 19:26'!
columnTitleForColumn: aColumn
	^columnTitles at: aColumn ifAbsent:[nil]! !

!GRIDReportResult methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/7/2011 15:06'!
hasCellValueForReportSubject: aReportSubject inColumn: aGRIDReportColumn 
	^ (self cellValuesInColumn:  aGRIDReportColumn ) includesKey: aReportSubject ! !

!GRIDReportResult methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 5/28/2012 17:49'!
hasResolvedAllCellValues
	^ self cellValues values allSatisfy:  [:columnValues | (columnValues size = self reportSubjects size) and:[(columnValues includes: nil) not ]]! !

!GRIDReportResult methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/11/2011 18:51'!
initialize 
	super initialize.
	cellValues := Dictionary new.
	totalValues := Dictionary new.
	columnTitles := Dictionary new.! !

!GRIDReportResult methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 08/22/2012 19:33'!
isEmptyResult
	^self cellValues isEmpty & reportSubjects isNil! !

!GRIDReportResult methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 6/7/2012 15:32'!
removeReportSubject: aReportSubject
	reportSubjects remove: aReportSubject ! !

!GRIDReportResult methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 07/24/2012 19:35'!
reportColumns
	^self cellValues keys! !

!GRIDReportResult methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 07/31/2012 16:26'!
reportColumns: someReportColumns
	^reportColumns := someReportColumns! !

!GRIDReportResult methodsFor: 'accessing' stamp: 'carlaGriggio 6/8/2012 18:54'!
reportSubjects
	^ reportSubjects ifNil:[#()]! !

!GRIDReportResult methodsFor: 'accessing' stamp: 'carlaGriggio 10/7/2011 13:23'!
reportSubjects: anArray 
	reportSubjects := anArray! !

!GRIDReportResult methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/7/2011 13:26'!
saveCellResult: aCellResult forColumn: aGRIDReportColumn andReportSubject: aReportSubject 
	(self cellValuesInColumn: aGRIDReportColumn) at: aReportSubject put: aCellResult ! !

!GRIDReportResult methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/11/2011 18:50'!
saveColumnTitle: aTitle forColumn: aColumn
	columnTitles at: aColumn put: aTitle ! !

!GRIDReportResult methodsFor: 'accessing' stamp: 'carlaGriggio 07/31/2012 11:06'!
saveTotalValueOf: aTotal forColumn:  aColumn inEvaluationContext: anEvaluationContext
	|totalResult|
	totalResult := (((aColumn isAgreggableBy: aTotal ) and:[anEvaluationContext cellResult isAggregable])
		ifFalse:[NullAgregationResult uniqueInstance]
		ifTrue:[aTotal totalForColumn: aColumn fromReportResult: self ]).
	(self totalValuesInColumn: aColumn) at: aTotal put: totalResult.! !

!GRIDReportResult methodsFor: 'accessing' stamp: 'carlaGriggio 3/20/2012 14:56'!
totalValueToPrintOf: aTotal forColumn:  aGRIDReportColumn
	^(aGRIDReportColumn isAgreggableBy: aTotal)
		ifTrue:[((self totalValuesInColumn: aGRIDReportColumn) at: aTotal ifAbsent:[NullAgregationResult uniqueInstance] ) asCurrencyString]
		ifFalse:['' ] ! !

!GRIDReportResult methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/7/2011 14:38'!
totalValuesInColumn: aGRIDReportColumn 
	totalValues at: aGRIDReportColumn ifAbsentPut: [Dictionary new].
	^totalValues at: aGRIDReportColumn! !

Object subclass: #GRIDSumAgregation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Core'!

GRIDSumAgregation class
	instanceVariableNames: 'Instancia'!

GRIDSumAgregation class
	instanceVariableNames: 'Instancia'!

GRIDSumAgregation subclass: #GRIDAvgAgregation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Core'!

!GRIDAvgAgregation methodsFor: 'as yet unclassified' stamp: 'cfg 4/19/2010 11:17'!
agregacionDe: unaColeccionDeNumeros
	^ (super agregacionDe: unaColeccionDeNumeros ) / unaColeccionDeNumeros size! !

!GRIDAvgAgregation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/12/2012 18:31'!
asString 
	^'Promedio'! !

!GRIDAvgAgregation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/12/2012 18:31'!
displayString 
self deprecated: 'Usar asString'.
	^'Promedio'! !

!GRIDSumAgregation class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 10:31'!
uniqueInstance
	^Instancia ifNil:[Instancia := self new].! !

!GRIDSumAgregation methodsFor: 'as yet unclassified' stamp: 'cfg 4/19/2010 11:18'!
agregacionDe: unaColeccionDeNumeros
	^unaColeccionDeNumeros inject:0 into:[:tot :num | tot + num]! !

!GRIDSumAgregation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/12/2012 18:31'!
asString 
	^'Sumatoria'! !

!GRIDSumAgregation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/12/2012 18:31'!
displayString 
self deprecated: 'Usar asString'.
	^'Sumatoria'! !

Object subclass: #NullAgregationResult
	instanceVariableNames: ''
	classVariableNames: 'Instancia'
	poolDictionaries: ''
	category: 'GRID-Core'!

!NullAgregationResult class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 10:31'!
uniqueInstance
	^Instancia ifNil:[Instancia := self new]! !

!NullAgregationResult methodsFor: 'comparing' stamp: 'carlaGriggio 5/20/2011 19:33'!
< otroObjeto
^false! !

!NullAgregationResult methodsFor: 'comparing' stamp: 'carlaGriggio 5/20/2011 19:32'!
adaptToNumber: rcvr andSend:  selector
	^false! !

!NullAgregationResult methodsFor: 'comparing' stamp: 'carlaGriggio 5/20/2011 19:39'!
adaptToString: rcvr andSend:  selector
	^false! !

!NullAgregationResult methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 3/20/2012 14:58'!
asCurrencyString
	^''! !

!NullAgregationResult methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/12/2012 18:31'!
asString 
	^''! !

!NullAgregationResult methodsFor: 'comparing' stamp: 'carlaGriggio 5/20/2011 19:53'!
at: i
	"Algo horrible para poder comparar con strings y que siempre sea mayor"
	^255! !

!NullAgregationResult methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/12/2012 18:31'!
displayString 
self deprecated: 'Usar asString'.
	^''! !

!NullAgregationResult methodsFor: 'comparing' stamp: 'carlaGriggio 5/20/2011 19:49'!
isByteString 
	^false! !

!NullAgregationResult methodsFor: 'comparing' stamp: 'carlaGriggio 5/20/2011 19:49'!
size
	^'1000'! !

Object subclass: #NullPonderationTable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Core'!

!NullPonderationTable methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 6/15/2012 03:09'!
ponderacionDe: anObject
	^0! !

!NullPonderationTable methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 6/15/2012 03:04'!
sumaDePonderaciones 
	^1! !

Object subclass: #SumatoryAgregation
	instanceVariableNames: 'sujetosDeEvaluacion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Core'!

SumatoryAgregation class
	instanceVariableNames: 'Instancia'!

SumatoryAgregation class
	instanceVariableNames: 'Instancia'!

SumatoryAgregation subclass: #AverageAgregation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Core'!

!AverageAgregation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/12/2012 18:32'!
asString
	^'Total (Promedio)'! !

!AverageAgregation methodsFor: 'as yet unclassified' stamp: 'cfg 5/17/2010 12:49'!
denominadorParaPromedio
	^sujetosDeEvaluacion size! !

!AverageAgregation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/20/2011 22:09'!
denominatorFor: someReportSubjects
	^someReportSubjects  size
	! !

!AverageAgregation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/12/2012 18:32'!
displayString
self deprecated: 'Usar asString'.
	^'Total (Promedio)'! !

!AverageAgregation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/21/2011 13:34'!
title
	^'Promedio'! !

!AverageAgregation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 6/7/2012 15:45'!
totalForColumn: unaColumna fromReportResult: aGRIDReportResult
	^[(super totalForColumn: unaColumna fromReportResult: aGRIDReportResult) / (self denominatorFor: aGRIDReportResult reportSubjects )] on: ZeroDivide do:[:error | 0]! !

AverageAgregation subclass: #PonderatedAverageAgregation
	instanceVariableNames: 'tablaPonderacion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Core'!

!PonderatedAverageAgregation class methodsFor: 'as yet unclassified' stamp: 'cfg 5/17/2010 16:11'!
segunTabla: unaTablaPonderacion
	^self new tablaPonderacion: unaTablaPonderacion ! !

!PonderatedAverageAgregation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/12/2012 18:32'!
asString
	^'Total (Promedio Ponderado con tabla ', self tablaPonderacion nombre, ')'! !

!PonderatedAverageAgregation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 6/7/2012 17:37'!
cellValueInColumn: aGRIDReportColumn forSubject: aReportSubject fromReportResult: aGRIDReportResults
	^(super cellValueInColumn: aGRIDReportColumn forSubject: aReportSubject fromReportResult: aGRIDReportResults) * (tablaPonderacion ponderacionDe: aReportSubject )! !

!PonderatedAverageAgregation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 6/7/2012 18:47'!
denominatorFor: someReportSubjects
	^tablaPonderacion sumaDePonderaciones! !

!PonderatedAverageAgregation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/12/2012 18:32'!
displayString
self deprecated: 'Usar asString'.
	^'Total (Promedio Ponderado con tabla ', self tablaPonderacion nombre, ')'! !

!PonderatedAverageAgregation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 5/31/2012 17:41'!
initialize 
	super initialize.
	tablaPonderacion := NullPonderationTable new! !

!PonderatedAverageAgregation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 07/31/2012 12:01'!
shallowCopy
	^self copy! !

!PonderatedAverageAgregation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 5/31/2012 17:41'!
tablaPonderacion
	^ tablaPonderacion ! !

!PonderatedAverageAgregation methodsFor: 'as yet unclassified' stamp: 'cfg 5/17/2010 16:11'!
tablaPonderacion: unaTablaPonderacion
	tablaPonderacion := unaTablaPonderacion ! !

!PonderatedAverageAgregation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 5/31/2012 17:29'!
title
	^'Promedio Ponderado'! !

!SumatoryAgregation class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 10:31'!
uniqueInstance
	^Instancia ifNil:[Instancia := self new]! !

!SumatoryAgregation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/12/2012 18:32'!
asString
	^'Total (Sumatoria)'! !

!SumatoryAgregation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/7/2011 14:58'!
cellValueInColumn: aGRIDReportColumn forSubject: aReportSubject fromReportResult: aGRIDReportResults
	^aGRIDReportResults cellValueForColumn:  aGRIDReportColumn andSubject: aReportSubject ! !

!SumatoryAgregation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 6/7/2012 17:14'!
cssClass
	^'sumatoryAggregation'! !

!SumatoryAgregation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/12/2012 18:32'!
displayString
self deprecated: 'Usar asString'.
	^'Total (Sumatoria)'! !

!SumatoryAgregation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 6/7/2012 16:58'!
reportConfigurationView 
	^GRIDUIAggregationCell forAggregation: self! !

!SumatoryAgregation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 07/31/2012 12:01'!
shallowCopy
	^self! !

!SumatoryAgregation methodsFor: 'as yet unclassified' stamp: 'cfg 5/17/2010 12:47'!
sujetosDeEvaluacion: unosSujetosDeEvaluacion
	sujetosDeEvaluacion := unosSujetosDeEvaluacion ! !

!SumatoryAgregation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/21/2011 13:34'!
title
	^'Total'! !

!SumatoryAgregation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/7/2011 14:55'!
totalForColumn: aColumn fromReportResult: aReportResult
	^aReportResult  reportSubjects inject:0 into: [:total :aReportSubject | total + ( self cellValueInColumn: aColumn forSubject: aReportSubject  fromReportResult: aReportResult )]! !

!SumatoryAgregation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 17:07'!
valorDe: unSujeto enColumna: unaColumna
	^unaColumna valorGuardadoDe: unSujeto! !

Error subclass: #CellShouldNotBeResolved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Core'!

Error subclass: #CellValueNotResolvedError
	instanceVariableNames: 'column reportSubject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Core'!

!CellValueNotResolvedError methodsFor: 'accessing' stamp: 'carlaGriggio 10/6/2011 17:58'!
column
	^ column! !

!CellValueNotResolvedError methodsFor: 'accessing' stamp: 'carlaGriggio 10/6/2011 17:58'!
column: anObject
	column := anObject! !

!CellValueNotResolvedError methodsFor: 'accessing' stamp: 'carlaGriggio 10/6/2011 17:58'!
reportSubject
	^ reportSubject! !

!CellValueNotResolvedError methodsFor: 'accessing' stamp: 'carlaGriggio 10/6/2011 17:58'!
reportSubject: anObject
	reportSubject := anObject! !

Error subclass: #GRIDNoReportsToProcessError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Core'!

Error subclass: #NullCellValueError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Core'!

!NullCellValueError methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 5/28/2012 18:01'!
messageText
	^'No se pudo calcular un valor de celda'! !

!NullCellValueError methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 5/28/2012 18:01'!
possibleCauses 
	^#('El informe no tiene configurado un Resultado de Celda, ya sea de forma general o en alguna de sus columnas')! !

Error subclass: #ReportCannotBeBuiltError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Core'!
GRIDFactory initialize!
